<template>
  <div class="select-month">
    <select v-model="selectedMonth" @change="selectedMonthChange()">
      <option
        v-for="month in monthList"
        :value="{ month: month.month, year: month.year, label: month.label }"
        :key="month.label"
      >
        {{ month.label }}
      </option>
    </select>
  </div>
</template>
<script>
import moment from "moment";

export default {
  name: "SelectMonth",
  computed: {
    monthList() {
      return this.generateMonthList();
    }
  },
  data() {
    return {
      selectedMonth: null
    };
  },
  methods: {
    generateMonthList() {
      const months = [];
      let date = moment();
      for (let index = 0; index < 100; index++) {
        months.push({
          month: date.month(),
          year: date.year(),
          label: date.format("MMMM YYYY")
        });
        date.add(1, "months");
      }
      if (this.selectedMonth === null) this.selectedMonth = months[0];
      return months;
    },
    selectedMonthChange() {
      this.$emit("input", this.selectedMonth);
    }
  },
  mounted() {
    this.$emit("input", this.selectedMonth);
  }
};
</script>
<style>
.select-month select {
  font-size: 1.5em;
  text-align: center;
}
</style>
